import _useEffectState3 from "parsec-hooks/lib/effectStateHooks";
var _excluded = ["renderItem", "list", "className"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useMemo, useState } from 'react';
import { View } from 'remax/one';
import styles from './index.module.less';
import classNames from 'classnames';
import ScrollView from '../scroll-view';
import Visible from '../visible';
import { pinyin } from 'pinyin-pro';
export default (function (_ref) {
  var renderItem = _ref.renderItem,
      list = _ref.list,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, _excluded);

  var indexs = useMemo(function () {
    var obj = {};
    list.forEach(function (item) {
      var _renderItem = renderItem(item),
          _renderItem$index = _slicedToArray(_renderItem.index, 1),
          first = _renderItem$index[0];

      var _pinyin = pinyin(first, {
        pattern: 'initial',
        type: 'array'
      }),
          _pinyin2 = _slicedToArray(_pinyin, 1),
          index = _pinyin2[0];

      if (!obj[index]) {
        obj[index] = [];
      }

      obj[index].push(item);
    });
    var obj2 = {};
    Object.keys(obj).sort().forEach(function (i) {
      obj2[i.toUpperCase()] = obj[i];
    });
    return obj2;
  }, [list, renderItem]);

  var _useEffectState = _useEffectState3(Object.keys(indexs)[0]),
      _useEffectState2 = _slicedToArray(_useEffectState, 2),
      current = _useEffectState2[0],
      setCurrent = _useEffectState2[1];

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isHoverSlide = _useState2[0],
      setIsHoverSlide = _useState2[1];

  return /*#__PURE__*/React.createElement(ScrollView, _objectSpread({
    scrollY: true,
    className: classNames(styles.wrap, className),
    scrollIntoView: isHoverSlide ? "index".concat(current) : undefined
  }, props), /*#__PURE__*/React.createElement(View, {
    className: styles.current,
    style: {
      opacity: isHoverSlide ? 1 : 0
    }
  }, current), /*#__PURE__*/React.createElement(View, {
    className: styles.slide,

    /* eslint-disable-next-line @typescript-eslint/ban-ts-comment */
    // @ts-ignore
    onMouseEnter: function onMouseEnter() {
      setIsHoverSlide(true);
    },
    onMouseLeave: function onMouseLeave() {
      setIsHoverSlide(false);
    },
    onTouchStart: function onTouchStart() {
      setIsHoverSlide(true);
    },
    onTouchCancel: function onTouchCancel() {
      setIsHoverSlide(true);
    }
  }, Object.keys(indexs).map(function (i) {
    return /*#__PURE__*/React.createElement("div", {
      onTouchStart: function onTouchStart() {
        setCurrent(i);
      },

      /* eslint-disable-next-line @typescript-eslint/ban-ts-comment */
      // @ts-ignore
      onMouseMove: function onMouseMove() {
        setCurrent(i);
      },
      className: classNames(styles.slideItem, current === i && styles.slideActive),
      key: i
    }, i);
  })), Object.keys(indexs).map(function (i) {
    return /*#__PURE__*/React.createElement(React.Fragment, {
      key: i
    }, /*#__PURE__*/React.createElement(Visible, {
      onVisible: function onVisible() {
        if (!isHoverSlide) {
          setCurrent(i);
        }
      }
    }, /*#__PURE__*/React.createElement(View, {
      className: styles.index,
      id: "index".concat(i)
    }, i)), indexs[i].map(function (data) {
      return renderItem(data).node;
    }));
  }));
});